// script for xkas plus
arch snes.cpu; lorom

define bank0_cnt	288		// change this to expand bank 0 instances
define bank1_cnt	1792	// not really used, just a reminder

// test to kill the old dictionary data
org $8CB400
	fill 2564
// test to kill old text data
org $8EF000
	fill 3582	// pointers
org $8C8000
	fill 13312	// bank 0
org $8D8000
	fill 61120	// bank 1

// hack dictionary to use a new bank
org $80B982
	lda dictionary, x			// load dictionary byte
	clc
	adc #(dictionary&0xFFFF)	// build full pointer
org $80B991
	lda.b #(dictionary>>16)		// pointer bank, was 8C

// hack to expand text banks
// -- dialog --
org $80B5C0
	ldx.b #(dial_bank1>>16)
	cmp.w #{bank0_cnt}
org $80B5C7
	ldx.b #(dial_bank0>>16)
org $80B5D0
	lda dial_ptr_tbl, x

// -- no idea --
org $80B4F3
	lda.b #(dial_bank1>>16)
	cpx.w #{bank0_cnt}
org $80B4FA
	lda.b #(dial_bank0>>16)
org $80B50F
	lda dial_ptr_tbl, x			

// -- no idea --
org $80BBE1
	lda.b #(dial_bank1>>16)
	cpx.w #{bank0_cnt}
org $80BBE8
	lda.b #(dial_bank0>>16)
org $80BBF1
	lda dial_ptr_tbl, x

// -- no idea --
org $83D5A9
	lda.b #(dial_bank1>>16)
org $83D5B2
	lda dial_ptr_tbl, x

// ---------------------------------------
//
// THIS IS WHERE THE ROM IS BEING EXPANDED
// AND POPULATED WITH NEW DATA
//
// ---------------------------------------

// clear 6 banks
org $B08000
	fill 32*1024*6

// where the new dictionary goes
org $B08000
dictionary:
	incbin "dict.bin"

// notes about old text banks and pointers:

// pointer bank 0 = $8EF000, 288 instances
// text bank 0 = $8C8000
// pointer bank 1 = $8EF240, 1792 instances
// text bank 1 = $8D8000

// text banks can be encoded as full 64 KB blocks as
// the game uses a small hack to perform reads across
// 32 KB bank boundaries

org $B18000
dial_ptr_tbl:
	incbin "ptr0.bin"
	incbin "ptr1.bin"
	
org $B28000
dial_bank0:
	incbin "text0.bin"

org $B48000
dial_bank1:
	incbin "text1.bin"

// pad rom to 2 MB
org $BFFFFF
	db 0
